<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2012 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: infusion.php
| Version: 2.0.4
| Author: Yodix
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."pointx/infusion_db.php";

if (file_exists(INFUSIONS."pointx/locale/".$settings['locale'].".php")) {
	include INFUSIONS."pointx/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."pointx/locale/English.php";
}

$inf_title = $locale['pointx_info_00_000'];
$inf_description = $locale['pointx_info_00_001'];
$inf_version = "2.0.4";
$inf_developer = "Yodix";
$inf_email = "yodix@on-deck.eu";
$inf_weburl = "http://www.on-deck.eu";
$inf_folder = "pointx";

$inf_newtable[1] = DB_POINTX." (
pointx_id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT, 
pointx_name VARCHAR(255) NOT NULL DEFAULT '',
pointx_file VARCHAR(255) NOT NULL DEFAULT '',
pointx_points VARCHAR(50) NOT NULL DEFAULT '',
pointx_key VARCHAR(200) NOT NULL DEFAULT '',
PRIMARY KEY (pointx_id)
) ENGINE=MyISAM;";

$inf_newtable[2] = DB_FUNCTION_VALUES." (
value_id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT,
value_user MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
value_db VARCHAR(100) NOT NULL DEFAULT '',
value_field_id VARCHAR(100) NOT NULL DEFAULT '',
value_field_user VARCHAR(100) NOT NULL DEFAULT '',
value_value VARCHAR(100) NOT NULL DEFAULT '',
PRIMARY KEY (value_id)
) ENGINE=MyISAM;";

$inf_newtable[3] = DB_EVENT_LOG." (
event_id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT,
event_user MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
event_message VARCHAR(255) NOT NULL DEFAULT '',
event_points VARCHAR(50) NOT NULL DEFAULT '',
event_after_balance VARCHAR(50) NOT NULL DEFAULT '',
event_datestamp INT(10) UNSIGNED NOT NULL DEFAULT '0',
event_option TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
PRIMARY KEY (event_id),
KEY event_datestamp (event_datestamp)
) ENGINE=MyISAM;";

$inf_newtable[4] = DB_PX_TRANSFER." (
transfer_id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT,
transfer_form MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
transfer_to MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
transfer_message VARCHAR(255) NOT NULL DEFAULT '',
transfer_points VARCHAR(50) NOT NULL DEFAULT '',
transfer_datestamp INT(10) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (transfer_id),
KEY event_datestamp (transfer_datestamp)
) ENGINE=MyISAM;";

$inf_insertdbrow[1] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('scoring_enabled', '1', '".$inf_folder."')";
$inf_insertdbrow[2] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('pointx_update_system', '0', '".$inf_folder."')";
$inf_insertdbrow[3] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('scoring_negative', '0', '".$inf_folder."')";
$inf_insertdbrow[4] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('scoring_mm', '0', '".$inf_folder."')";
$inf_insertdbrow[5] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('scoring_group', '101', '".$inf_folder."')";
$inf_insertdbrow[6] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('scoring_event_log', '0', '".$inf_folder."')";
$inf_insertdbrow[7] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('max_points', '1000000', '".$inf_folder."')";
$inf_insertdbrow[8] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('min_points', '100', '".$inf_folder."')";
$inf_insertdbrow[9] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('min_action', 'no_action', '".$inf_folder."')";
$inf_insertdbrow[10] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('install_check', '0', '".$inf_folder."')";

$inf_insertdbrow[11] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('function_values', '1', '".$inf_folder."')";
$inf_insertdbrow[12] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('system_controller', '0', '".$inf_folder."')";

$inf_insertdbrow[13] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('forum_info_points', '1', '".$inf_folder."')";
$inf_insertdbrow[14] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('forum_disable_points', '', '".$inf_folder."')";
$inf_insertdbrow[15] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('scoring_rank', '0', '".$inf_folder."')";
$inf_insertdbrow[16] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('admins_in_panel', '1', '".$inf_folder."')";

$inf_insertdbrow[17] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('page_message', '', '".$inf_folder."')";
$inf_insertdbrow[18] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('page_list', '1', '".$inf_folder."')";
$inf_insertdbrow[19] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('page_transfer', '1', '".$inf_folder."')";
$inf_insertdbrow[20] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('page_transfer_negative', '0', '".$inf_folder."')";
$inf_insertdbrow[21] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('installed_pointxers', '', '".$inf_folder."')";
$inf_insertdbrow[22] = DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES('transfers_log', '10', '".$inf_folder."')";

$inf_insertdbrow[23] = DB_POINTX." (pointx_name, pointx_points, pointx_key) VALUES('".$locale['pointx_info_00_004']."', '1', '2dGusD15C8d6P2U6VU792F79b')";
$inf_insertdbrow[24] = DB_POINTX." (pointx_name, pointx_points, pointx_key) VALUES('".$locale['pointx_info_00_005']."', '2', '4UqTdv934pmwJ7b937xz7Y4SC')";
$inf_insertdbrow[25] = DB_POINTX." (pointx_name, pointx_points, pointx_key) VALUES('".$locale['pointx_info_00_006']."', '2', 'k58vyCzT1r9IPXE42aC6ept5L')";

$inf_droptable[1] = DB_POINTX;
$inf_droptable[2] = DB_FUNCTION_VALUES;
$inf_droptable[3] = DB_EVENT_LOG;
$inf_droptable[4] = DB_PX_TRANSFER;

$inf_deldbrow[1] = DB_SETTINGS_INF." WHERE settings_inf='".$inf_folder."'";

$inf_adminpanel[1] = array(
	"title" => $locale['pointx_info_00_002'],
	"image" => "pointx.gif",
	"panel" => "pointx_admin.php",
	"rights" => "PX"
);

$inf_sitelink[1] = array(
	"title" => $locale['pointx_info_00_003'],
	"url" => "pointx.php",
	"visibility" => "101"
);
?>