<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2012 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: PointX.class.php
| Version: 2.0.4
| Author: Yodix
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
class PointX {
	public $issetError = FALSE;
	public $msgError = array();
	
	public $disable = FALSE;
	public $oldupdate = FALSE;
	
	public $settings;
	public $userdata;
	
	public $navi = "";
	public $locale;
	
	public $usersIDs;
	public $postsIDs;
	
	const Version = "2.0.4";
	
	public function __construct () {
		global $settings, $userdata;
		
		include_once INCLUDES."infusions_include.php";
		
		$this->settings = get_settings("pointx");
		$this->userdata = $userdata;
		
		$this->InitLocale();
		
		if (isset($this->settings['install_check']) && $this->settings['install_check'] == 0) {
			$this->Setup();
			set_setting("install_check", 1, "pointx");
		}
		
		$inf_result = dbquery("SELECT inf_id, inf_version FROM ".DB_INFUSIONS." WHERE inf_folder='pointx'");
		if (dbrows($inf_result) != 0) {
			$inf_data = dbarray($inf_result);
			if (version_compare(PointX::Version, $inf_data['inf_version'], ">")) {
				$this->NextUpdate($inf_data['inf_version']);
			} else {
				if (FUSION_SELF == "infusions.php" && isset($_GET['defuse']) && $_GET['defuse'] == $inf_data['inf_id']) {
					$this->Uninstall();
				}
			}
		} else {
			$this->disable = TRUE;
		}
	}
	
	/* ### Funkcje Wewntrzne ### */
	
	private function Setup ($doInstall = TRUE) {
		if ($doInstall) {
			$result = dbquery("ALTER TABLE ".DB_USERS." ADD user_points VARCHAR(50) NOT NULL DEFAULT '0'");
			if (!$result) { return FALSE; } else { return TRUE; }
		} elseif (isset($this->settings['px_enabled'])) {
			$this->oldupdate = TRUE;
			$this->disable = TRUE;
		} else {
			return FALSE;
		}
	}
	
	private function NextUpdate ($current_version) {
		include_once INCLUDES."infusions_include.php";
		
		if ($current_version == "2.0.3") {
			$AddOpt = set_setting("pointx_update_system", 0, "pointx");
			$this->settings['pointx_update_system'] = 0;
			$AddOpt = set_setting("forum_disable_points", "", "pointx");
			$this->settings['forum_disable_points'] = "";
			$AddOpt = set_setting("installed_pointxers", "", "pointx");
			$this->settings['installed_pointxers'] = "";
			$AddOpt = set_setting("transfers_log", 10, "pointx");
			$this->settings['transfers_log'] = 10;
			
			$AddTable = dbquery("CREATE TABLE ".DB_PX_TRANSFER." (
			transfer_id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT,
			transfer_form MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
			transfer_to MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
			transfer_message VARCHAR(255) NOT NULL DEFAULT '',
			transfer_points VARCHAR(50) NOT NULL DEFAULT '',
			transfer_datestamp INT(10) UNSIGNED NOT NULL DEFAULT '0',
			PRIMARY KEY (transfer_id),
			KEY event_datestamp (transfer_datestamp)
			) ENGINE=MYISAM;");
		}
		$verUpdate = dbquery("UPDATE ".DB_INFUSIONS." SET inf_version='".PointX::Version."' WHERE inf_folder='pointx'");
		
		return TRUE;
	}
	
	private function Uninstall ($doUninstall = TRUE) {
		if ($doUninstall) {
			$result = dbquery("ALTER TABLE ".DB_USERS." DROP user_points");
			if (!$result) { return FALSE; } else { return TRUE; }
		} else {
			return FALSE;
		}
	}
	
	private function InitLocale () {
		global $settings;
		
		if (file_exists(INFUSIONS."pointx/locale/".$settings['locale'].".php")) {
			include INFUSIONS."pointx/locale/".$settings['locale'].".php";
		} else {
			include INFUSIONS."pointx/locale/English.php";
			$this->AddError("show_info", "locale");
		}
		
		$this->locale = $locale;
	}
	
	private function DoAction ($userId) {
		global $settings;
		
		$result = dbquery("SELECT user_id, user_name, user_email FROm ".DB_USERS." WHERE user_id='".$userId."'");
		if (dbrows($result) == 1 && $this->settings['min_action'] == "ban") {
			require_once INCLUDES."sendmail_include.php";
			require_once INCLUDES."suspend_include.php";
			
			$data = dbarray($result);
			$result2 = dbquery("UPDATE ".DB_USERS." SET user_status='1', user_actiontime='0', user_points='0' WHERE user_id='".$userId."'");
			suspend_log($userId, 4, $this->locale['pointx_pxclass_01_002'], true);
			$message = str_replace("[USER_NAME]", $data['user_name'], $this->locale['pointx_pxclass_01_001']);
			$message = str_replace("[REASON]", stripinput($this->locale['pointx_pxclass_01_001']), $message);
			sendemail($data['user_name'], $data['user_email'], $settings['siteusername'], $settings['siteemail'], $this->locale['pointx_pxclass_01_000'], $message);
		} elseif (dbrows($result) == 1 && $this->settings['min_action'] == "no_action") {
			$result2 = dbquery("UPDATE ".DB_USERS." SET user_points='0' WHERE user_id='".$userId."'");
		}
	}
	
	private function SaveUserPoints ($userId, $userPoints) {
		$result = dbquery("UPDATE ".DB_USERS." SET user_points='".$userPoints."' WHERE user_id='".$userId."'");
		if ($result) { return TRUE; } else { return FALSE; }
	}
	
	private function AddError ($action, $message) {
		$this->issetError = TRUE;
		$this->msgError[$action][$message] = TRUE;
	}
	
	/* ### Funkcje Zewntrzne ### */
	
	public function RenderNavi () {
		return $this->navi;
	}
	
	public function PolishWords ($number) {
		if (count(explode(".", $number)) < 2) {
			$number = isnum($number) ? $number : 0;
			
			$digit = substr($number, -1, 1);
			$digits = substr($number, -2, 2);
			
			if ($number == 1) {
				$return = $this->locale['pointx_pxclass_00_000'];
			} elseif (($digit == 2 || $digit == 3 || $digit == 4) && ($digits != 12 && $digits != 13 && $digits != 13)) {
				$return = $this->locale['pointx_pxclass_00_001'];
			} else {
				$return = $this->locale['pointx_pxclass_00_002'];
			}
			
			return $return;
		} else {
			return $this->locale['pointx_pxclass_00_003'];
		}
	}
	
	public function GetPointXer ($key) {
		$result = dbquery("SELECT pointx_id, pointx_name, pointx_points FROM ".DB_POINTX." WHERE pointx_key='".$key."'");
		if (dbrows($result) != 0) {
			$data = dbarray($result);
			
			if ($this->settings['scoring_mm'] == 1) {
				$data['pointx_points'] = number_format($data['pointx_points'], 2);
			} elseif ($this->settings['scoring_mm'] == 0) {
				$data['pointx_points'] = explode(".", $data['pointx_points']);
				
				if (count($data['pointx_points']) == 2) {
					$data['pointx_points'] = $data['pointx_points'][0];
					$result = dbquery("UPDATE ".DB_POINTX." SET pointx_points='".$data['pointx_points']."' WHERE pointx_key='".$key."'");
				} elseif ($data['pointx_points'] == 1) {
					$data['pointx_points'] = $data['pointx_points'];
				} else {
					$data['pointx_points'] = $data['pointx_points'][0];
					$result = dbquery("UPDATE ".DB_POINTX." SET pointx_points='".$data['pointx_points']."' WHERE pointx_key='".$key."'");
				}
			}
			
			return array("id" => $data['pointx_id'], "name" => $data['pointx_name'], "points" => $data['pointx_points']);
		} else {
			return FALSE;
		}
	}
	
	public function GetUserPoints ($userId) {
		$result = dbquery("SELECT user_points FROM ".DB_USERS." WHERE user_id='".$userId."'");
		if (dbrows($result) != 0) {
			$data = dbarray($result);
			
			return $data['user_points'];
		} else {
			return "get_error";
		}
	}
	
	public function AddPoints ($userId, $key, $onlyPoints = FALSE, $name = "") {
		if ($this->settings['scoring_enabled'] == 1) {
			if ($onlyPoints) {
				if ($this->settings['scoring_mm'] == 1) {
					$PointXer = array("id" => 0, "name" => $name, "points" => (is_numeric($key) ? $key : 0));
				} elseif ($this->settings['scoring_mm'] == 0) {
					$PointXer = array("id" => 0, "name" => $name, "points" => (isnum($key) ? $key : 0));
				}
			} else {
				$PointXer = $this->GetPointXer($key);
			}
			
			if ($PointXer) {
				$userId = isnum($userId) ? $userId : 0;
				$user_points = $this->GetUserPoints($userId);
				if ($user_points != "get_error") {
					if ($this->settings['scoring_mm'] == 1) {
						$operation = number_format($user_points + $PointXer['points'], 2, ".", "");
					} elseif ($this->settings['scoring_mm'] == 0) {
						$operation = number_format($user_points + $PointXer['points'], 0, ".", "");
					}
					if ($operation > $this->settings['max_points']) {
						$save = $this->SaveUserPoints($userId, $this->settings['max_points']);
						if ($save) $this->EventLog($userId, $onlyPoints ? $name : sprintf($this->locale['pointx_pxclass_02_000'], $PointXer['name']), $PointXer['points'], $this->settings['max_points'], 1);
					} else {
						$save = $this->SaveUserPoints($userId, $operation);
						if ($save) $this->EventLog($userId, $onlyPoints ? $name : sprintf($this->locale['pointx_pxclass_02_000'], $PointXer['name']), $PointXer['points'], $operation, 1);
					}
				} else {
					return "user_data_error";
				}
			} else {
				return "pointxer_get_error";
			}
		}
	}
	
	public function TakePoints ($userId, $key, $onlyPoints = FALSE, $name = "") {
		if ($this->settings['scoring_enabled'] == 1) {
			if ($onlyPoints) {
				if ($this->settings['scoring_mm'] == 1) {
					$PointXer = array("id" => 0, "name" => $name, "points" => (is_numeric($key) ? $key : 0));
				} elseif ($this->settings['scoring_mm'] == 0) {
					$PointXer = array("id" => 0, "name" => $name, "points" => (isnum($key) ? $key : 0));
				}
			} else {
				$PointXer = $this->GetPointXer($key);
			}
			
			if ($PointXer) {
				$userId = isnum($userId) ? $userId : 0;
				$user_points = $this->GetUserPoints($userId);
				if ($user_points != "get_error") {
					if ($this->settings['scoring_mm'] == 1) {
						$operation = number_format($user_points - $PointXer['points'], 2, ".", "");
					} elseif ($this->settings['scoring_mm'] == 0) {
						$operation = number_format($user_points - $PointXer['points'], 0, ".", "");
					}
					$NoMin = abs($operation) > $this->settings['min_points'] ? TRUE : FALSE;

					if ($this->settings['scoring_negative'] == 1) {
						if ($operation < 0 && !$NoMin) {
							$save = $this->SaveUserPoints($userId, $operation);
							if ($save) $this->EventLog($userId, ($onlyPoints ? $name : sprintf($this->locale['pointx_pxclass_02_001'], $PointXer['name'])), $PointXer['points'], $operation, 2);
						} elseif ($operation < 0 && $NoMin) {
							$save = $this->SaveUserPoints($userId, 0);
							$this->DoAction($userId);
							if ($save) $this->EventLog($userId, $onlyPoints ? $name : sprintf($this->locale['pointx_pxclass_02_001'], $PointXer['name']), $PointXer['points'], 0, 2);
						} elseif ($operation > 0) {
							$save = $this->SaveUserPoints($userId, $operation);
							if ($save) $this->EventLog($userId, $onlyPoints ? $name : sprintf($this->locale['pointx_pxclass_02_001'], $PointXer['name']), $PointXer['points'], $operation, 2);
						}
					} else {
						if ($operation >= 0) {
							$save = $this->SaveUserPoints($userId, $operation);
							if ($save) $this->EventLog($userId, $onlyPoints ? $name : sprintf($this->locale['pointx_pxclass_02_001'], $PointXer['name']), $PointXer['points'], $operation, 2);
						} else {
							$save = $this->SaveUserPoints($userId, 0);
							if ($save) $this->EventLog($userId, $onlyPoints ? $name : sprintf($this->locale['pointx_pxclass_02_001'], $PointXer['name']), $PointXer['points'], 0, 2);
							$this->DoAction($userId);
						}
					}
				} else {
					return "user_data_error";
				}
			} else {
				return "pointxer_get_error";
			}
		}
	}
	
	public function EventLog ($user_id, $message, $points, $balance, $option = 0) {
		if ($this->settings['scoring_event_log'] == 1) {
			$CheckDisabled = dbcount("(event_id)", DB_EVENT_LOG, "event_option='4'");
			if ($CheckDisabled == 0) {
				$result = dbquery("INSERT INTO ".DB_EVENT_LOG." (event_user, event_message, event_points, event_after_balance, event_datestamp, event_option) VALUES ('".$user_id."', '".$message."', '".$points."', '".$balance."', '".time()."', '".$option."')");
				if ($result) { return TRUE; } else { return FALSE; }
			} else {
				return TRUE;
			}
		} else {
			return TRUE;
		}
	}
	
	public function TransferLog ($UserFrom, $UserTo, $Points, $Comment) {
		if ($UserFrom == $UserTo) return FALSE;
		if (dbcount("(transfer_id)", DB_PX_TRANSFER, "transfer_to='".$UserTo."'") >= $PointX->settings['transfers_log']) {
			$del_result = dbquery("DELETE FROM ".DB_PX_TRANSFER." WHERE transfer_to='".$UserTo."' ORDER BY transfer_datestamp ASC LIMIT 1");
			if (!$del_result) return FALSE;
		}
		$result = dbquery("INSERT INTO ".DB_PX_TRANSFER." (transfer_form, transfer_to, transfer_message, transfer_points, transfer_datestamp) VALUES ('".$UserFrom."', '".$UserTo."', '".$Comment."', '".$Points."', '".time()."')");
		return $result ? TRUE : FALSE;
	}
	
	/* ### Inne Funkcje ### */
	
	public function ShowUserPoints ($userID, $divider = FALSE) {
		$result = dbquery("SELECT user_points FROM ".DB_USERS." WHERE user_id='".$userID."'");
		if (dbrows($result) != 0) {
			$data = dbarray($result);
			
			if ($this->settings['scoring_mm'] == 1) {
				return number_format($data['user_points'], 2, ".", ($divider ? "'" : ""));
			} elseif ($this->settings['scoring_mm'] == 0) {
				return number_format($data['user_points'], 0, ".", ($divider ? "'" : ""));
			}
		}
	}
	
	public static function GenKey ($length = 5) {
		$chars = array("abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ", "123456789");
		$count = array((strlen($chars[0]) - 1), (strlen($chars[1]) - 1));
		$key = "";
		for ($i = 0; $i < $length; $i++) {
			$type = mt_rand(0, 1);
			$key .= substr($chars[$type], mt_rand(0, $count[$type]), 1);
		}
		if (dbcount("(pointx_id)", DB_POINTX, "pointx_key='".$key."'") != 0) {
			return PointX::GenKey($length);
		} else {
			return $key;
		}
	}
	
	public function GenStatus ($status) {
		global $settings;
		
		if (isset($status) && !isset($message)) {
			if (file_exists(INFUSIONS."pointx/system/errors/".$settings['locale'].".php")) {
				include_once INFUSIONS."pointx/system/errors/".$settings['locale'].".php";
			} else {
				include_once INFUSIONS."pointx/system/errors/English.php";
			}
			
			if (isset($message)) {	return "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; }
		}
	}
}
?>