<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright © 2002 - 2012 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: PointXers.class.php
| Version: 2.0.4
| Author: Yodix
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
class PointXers {
	private $PointX = FALSE;
	private $Action = "execute";
	private $_Errors = NULL;
	private $_Data = NULL;
	private $_FunctionValues = NULL;
	
	const PointXer = TRUE;
	
	public function __construct ($PointX, $PointXer, $classAction = "execute") {
		global $settings;
		
		$this->PointX = $PointX;
		$this->Action = $classAction;
		
		if (file_exists(INFUSIONS."pointx/pointxers/".$PointXer."/pointxer.php")) {
			if (file_exists(INFUSIONS."pointx/pointxers/".$PointXer."/locale/".$settings['locale'].".php")) {
				include INFUSIONS."pointx/pointxers/".$PointXer."/locale/".$settings['locale'].".php";
			} else {
				include INFUSIONS."pointx/pointxers/".$PointXer."/locale/English.php";
			}
			include INFUSIONS."pointx/pointxers/".$PointXer."/pointxer.php";
			
			return TRUE;
		} else {
			$this->_Errors = "pointxer_file_error";
			
			return FALSE;
		}
	}
	
	public function GetData () {
		if ($this->_Data !== NULL) {
			return $this->_Data;
		} else {
			return FALSE;
		}
	}
	
	public function GetFunctionValues () {
		if ($this->_FunctionValues !== NULL) {
			return $this->_FunctionValues;
		} else {
			return FALSE;
		}
	}
	
	public function GetResult () {
		if ($this->_Errors === NULL) {
			return "no_errors";
		} else {
			return $this->_Errors;
		}
	}
	
	private function InsertData ($name, $value) {
		if (in_array($name, array("name", "desc", "version", "px_ver", "code"))) {
			if ($name == "name") $value = trim(stripinput($value));
			if ($name == "desc") $value = trim(stripinput($value));
			if ($name == "version") $value = isnum(str_replace(".", "", $value)) ? $value : "1.0.0";
			if ($name == "px_ver") $value = isnum(str_replace(".", "", $value)) ? $value : PointX::Version;
			if ($name == "code") strlen($value) == 30 ? $value : PointX::GenKey(30);
			
			$this->_Data[$name] = $value;
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	private function FunctionValues ($TableName, $TableFieldId, $TableFieldUser, $Catalyst = "") {
		if (!empty($TableName) && !empty($TableFieldId) && !empty($TableFieldUser)) {
			if (dbrows(dbquery("SHOW TABLES LIKE '".$TableName."'")) != 0) {
				$this->_FunctionValues = array("table" => $TableName, "field_id" => $TableFieldId, "field_user" => $TableFieldUser, "catalyst" => $Catalyst);
				return TRUE;
			} else {
				return FALSE;
			}
		} else {
			return FALSE;
		}
	}
}
?>